/* Pebble CDEF.c
 *
 * This is my quick & dirty PICT CDEF for handling the non-standard push buttons
 * called for in the User Interface Document. I refer to the zoom buttons found
 * in the border of the Window frame.
 *
 * 11 March 95 MDT
 */
/* currently, this code is remarkably uncommented. c'est la vie. */

/* Data Types */

struct CtlPictRec {
	PicHandle	up,
				down;
};
typedef struct CtlPictRec CtlPictRec, *CtlPictPtr;



/* Prototypes */

void DrawMyControl(int varCode,ControlHandle theControl);
void DisposeMyControl(ControlHandle theControl);
void InitMyControl(short varCode,ControlHandle theControl);
pascal long main(short varCode,ControlHandle theControl,short message,long param);



/* Code */

pascal long main(short varCode,ControlHandle theControl,short message,long param)
{
	long		result = 0;
	SignedByte	saveHState = HGetState((Handle)theControl);
	Point		testPt;
	
	HLockHi((Handle)theControl);
	
	switch (message) {
	case initCntl:
		InitMyControl(varCode, theControl);
		break;
	case drawCntl:
		if ((*theControl)->contrlVis == 255)
			DrawMyControl(varCode,theControl);
		break;
	case testCntl:
		if ((*theControl)->contrlHilite != 255) {
			testPt.h = param & 0xFFFF;
			testPt.v = (param >> 16) & 0xFFFF;
			if (PtInRect(testPt,&(*theControl)->contrlRect))
				result = inButton;
		}
		break;
	case calcCRgns:
		param &= 0x00FFFFFF;
		RectRgn((RgnHandle)param,&(*theControl)->contrlRect);
		break;
	
	case dispCntl:
		DisposeMyControl(theControl);
		break;
	}

	HSetState((Handle)theControl,saveHState);
	return result;
}	

void InitMyControl(short varCode,ControlHandle theControl)
{
	Rect		r;
	CtlPictPtr	picts = nil;
	short		value;
	
	picts = (CtlPictPtr) NewPtr (sizeof(CtlPictRec));
	if (!picts) goto foo;
	picts->up = picts->down = nil;
	
	picts->up = GetPicture(GetCtlMin(theControl));
	if (!picts->up) goto foo;
	DetachResource((Handle)picts->up);
	
	picts->down = GetPicture (GetCtlMax(theControl));
	if (!picts->down) goto foo;
	DetachResource((Handle)picts->down);

	// since we can write to Data directly, it isn't really a handle. Memory is not moved.
	(*theControl)->contrlData = (Handle)picts;
		
	r = (*picts->up)->picFrame;
	SizeControl(theControl, r.right - r.left , r.bottom - r.top);
	
	//if (varCode == 1) {
	value = GetCtlValue(theControl);
	SetCtlMax(theControl, 1);
	SetCtlMin(theControl, 0);
	SetCtlValue(theControl, value);
	//}
	return;

foo:
	if (picts) {
		if (picts->up) {
			DisposeHandle((Handle)picts->up);  // We can't use ReleaseResource here.
		}
		DisposePtr((Ptr)picts);
	}
	return;
}

void DisposeMyControl(ControlHandle theControl)
{
	CtlPictPtr	picts = (CtlPictPtr)(*theControl)->contrlData;

	if (picts) {		// be a little careful
		DisposeHandle((Handle)picts->up);
		DisposeHandle((Handle)picts->down);
		DisposePtr((Ptr)picts);
	}
}

/* This routine is getting hard to read; 3/18/95 MDT */
void DrawMyControl(int varCode,ControlHandle theControl)
{
	CtlPictPtr		picts = (CtlPictPtr)(*theControl)->contrlData;
	PicHandle		thePict = nil;
	GrafPtr			savePort;
	RgnHandle		saveClip;
	RGBColor		grey1,
					grey2,
					black,
					saveHilight,
					saveFore,
					saveBack;
	Ptr 			HiliteMode = (Ptr)0x938; 
	Boolean			isColor;
	PixMapHandle	pixMap;
	
	if (!picts) return;   // oops
	
	/* Set port and clipping regions */
	GetPort(&savePort);
	SetPort((GrafPtr)(*theControl)->contrlOwner);
	saveClip = NewRgn();
	GetClip(saveClip);
	ClipRect(&(*theControl)->contrlRect);
	
	/* Determine local bit depth */
	pixMap = ((CGrafPtr)(*theControl)->contrlOwner)->portPixMap; 
	HLock((Handle)pixMap);
	isColor = ((* pixMap)->pixelSize!=1) ? 1 : 0;
	HUnlock((Handle)pixMap);

	/* Set some colors */
	if (isColor) {
		grey1.red  = 0xEEEE; grey1.green  = 0xEEEE; grey1.blue = 0xEEEE;
		grey2.red  = 0xAAAA; grey2.green  = 0xAAAA; grey2.blue = 0xAAAA;
		black.red = 0x0;    black.green = 0x0   ; black.blue= 0x0;
		saveFore = ((CGrafPtr)(*theControl)->contrlOwner)->rgbFgColor;
		saveBack = ((CGrafPtr)(*theControl)->contrlOwner)->rgbBkColor;
	}
	
	switch (varCode) {
	case 0:
		if (isColor) {
			if ((*theControl)->contrlHilite == 0) {
				/* for manual flashing  */
				if (GetCtlValue(theControl)==0)	{	
					thePict = picts->up; 
				} else {
					thePict = picts->down;
				}
			} else if ( ((*theControl)->contrlHilite > 0) && 
						((*theControl)->contrlHilite <255)) {
				thePict = picts->down;
			} else { // if contrlHilite == 255
				thePict = nil;
			}
		} else {
			if ((*theControl)->contrlHilite != 255)
				thePict = picts->up; 
		}
			
		if (thePict) {
			HLock((Handle)thePict);
			DrawPicture(thePict,&(*theControl)->contrlRect);
			HUnlock((Handle)thePict);
			if	((!isColor) && ((*theControl)->contrlHilite > 0) && 
				((*theControl)->contrlHilite <255)) {
				Rect r = (*theControl)->contrlRect;
				InsetRect(&r, 1, 1);
				InvertRect(&r);
			}			
		} else {
			if (isColor) {
				RGBForeColor(&grey1);
				PaintRect(&(*theControl)->contrlRect);
				RGBForeColor(&black);
				FrameRect(&(*theControl)->contrlRect);
			} else {
				EraseRect(&(*theControl)->contrlRect);
				FrameRect(&(*theControl)->contrlRect);
			}
		}
		break;
	case 1:
		if (isColor) {
			if ((*theControl)->contrlHilite != 255) {
				if (GetCtlValue(theControl) == 1) {
					thePict = picts->down;
				} else if (GetCtlValue(theControl) == 0) {
					thePict = picts->up;
				} else {
					thePict = nil;
				}
			} else {
				thePict = nil;
			}
		} else {
			if ((*theControl)->contrlHilite != 255) {
				thePict = picts->up;
			}
		}
		
		if (thePict) {
			HLock((Handle)thePict);
			DrawPicture(thePict,&(*theControl)->contrlRect);
			HUnlock((Handle)thePict);
			
			/* If the pict is selected */
			if (((*theControl)->contrlHilite > 0) && ((*theControl)->contrlHilite < 255)) {
				if (isColor) {
					if (GetCtlValue(theControl)) {
						grey1.red  = 0xDDDD; grey1.green  = 0xDDDD; grey1.blue = 0xDDDD;
					}
					saveHilight = (*((GVarHandle)((CGrafPtr)(*theControl)->contrlOwner)->grafVars))->rgbHiliteColor;
					RGBBackColor(&grey2);
					HiliteColor(&grey1);
					BitClr(HiliteMode, pHiliteBit);
					InvertRect(&(*theControl)->contrlRect);
					HiliteColor(&saveHilight);
				} else {
					Rect r = (*theControl)->contrlRect;
					InsetRect(&r, 1, 1);
					InvertRect(&r);
				}
			} else { /* If the pict is not selected, but it has value 1 when black/white */
				if (GetCtlValue(theControl) && !isColor) {
					Rect r = (*theControl)->contrlRect;
					InsetRect(&r, 1, 1);
					InvertRect(&r);
				}
			}
		} else { /* If no Pict is selected (i.e. the control is inactive) */
			if (isColor) {
				RGBForeColor(&grey1);
				PaintRect(&(*theControl)->contrlRect);
				RGBForeColor(&black);
				FrameRect(&(*theControl)->contrlRect);
			} else {
				EraseRect(&(*theControl)->contrlRect);
				FrameRect(&(*theControl)->contrlRect);
			}
		}
		
		break;
	default:
		;
	}
	
	if (isColor) {
		RGBForeColor(&saveFore);
		RGBBackColor(&saveBack);
	}
	
	SetClip(saveClip);
	DisposeRgn(saveClip);
	SetPort(savePort);
}