/*
 * TileInfoDLOG.c
 */
/* 5/15/96 - start conversion to multi-pane dialog box.
 */

#include "Alertsx.h"
#include "TileInfo.h"
#include "Monsters.h"
#include "Tiles.h"
#include "Scenario.h"
#include "Menusx.h"
#include "StrNUtil.h"
#include "TileMenuCommon.h"
#include "DLOGUtil.h"
#include "MMR.h"

#include "MultiPane.h" // MDT 5/15/96

//#define kTileInfoDLOGID		132
#define kTileInfoDLOGID		150

#define kOK					1
#define kCancel				2
#define kTile				3
#define kTileType			4
#define kTileOnTopOf		5
#define kXPosition			6
#define kYPosition			7
#define kTLKSID				8
#define kInclination		9
#define kPositionLit		11
#define kBehaviorLit		14
#define kPosBox				19
#define kBehBox				18

#define kBadTileDLOGID		133
#define kBadRangeDLOGID		134

void LoadTileInfoDLOG(DialogPtr d, MonsterRec *m);
void DrawControlGroup(Rect controlGroup, Rect caption);
void DrawTileInfoDLOG(DialogPtr d);
pascal Boolean TileInfoKeyProc(DialogPtr d, EventRecord *e, short *itemHit);
void SaveTileInfoDLOG(DialogPtr d,short mapID, short monsID);
void TIDrawTilePopup(DialogPtr d);
Boolean TIIsTilePopupClick(DialogPtr d,Point localPt);
void DoBadTileDialog (void);
void DoBadRangeDialog (Str255 itemName, long max);

long mpSize;

void DoTileInfoDLOG(short mapID, Point mapPt)
{
	DialogPtr d;
	Boolean done = false;
	GrafPtr save;
	ModalFilterUPP upp;
	MonsterRec m,mNew;
	short itemHit, savedTMI;
	unsigned char *a; 
	
	Handle typeControl=nil;
	
	mpSize = gScenario.outsideMapsSize[mapID].h; // mdt 3/11/96
	
	savedTMI = GetTMCheckedItem();
	
	BuildStandingOnMenu();
	FindMonsterByPosition(mapID, mapPt,&m);
	if (m.monsTileType < 1) return;

	GetPort(&save);
	d = GetNewMPDialog(kTileInfoDLOGID, nil, (WindowPtr)-1L); // MDT 5/15/96
	if (!d) {
		DoError("\pCould not load TileInfoDLOG!",0,kNotFatal);
		return;
	}
	SetMPDialogPane(d,-1);
//	LoadTileInfoDLOG(d,&m);

	ShowWindow(d);
	SetPort(d);
	(void) SetDialogDefaultItem(d,1);
	(void) SetDialogCancelItem(d,2);

	upp = NewModalFilterProc(TileInfoKeyProc);

	while (!done) {
		ModalDialog(upp,&itemHit);
		
		switch (itemHit) {
		case 1: // ok
		//	SaveTileInfoDLOG(d,mapID,m.monsNumber);

			// adjust map
			a = (unsigned char *)*gScenario.outsideMaps[mapID].map;
			FindMonsterByNumber(mapID, m.monsNumber, &mNew);
			//   remove old monster
			a[(mpSize*m.monsPosition.v) + m.monsPosition.h] = (unsigned char)(mNew.monsTileOnTopOf);
			//   add new monster
			a[(mpSize*mNew.monsPosition.v) + mNew.monsPosition.h] = (unsigned char)(mNew.monsTileType);

			done = true;
			break;
		case 2:
			done = true;
			break;
		case 5: // changing our item type
			GetDItem2(d,5,nil,&typeControl,nil);
			if (!typeControl) break;
			switch (GetCtlValue((ControlHandle)typeControl)) {
			case 1: // normal control
				SetMPDialogPane(d,-1);
				break;
			case 3: // monster
				SetMPDialogPane(d,0);
				break;
			default:
				SetMPDialogPane(d,-1);
			}			
		default:
			;
		}
	}
	CheckTMItem(savedTMI);
	DisposeRoutineDescriptor(upp);
	SetPort(save);
	DisposeMPDialog(d);
}

/*
 * LoadTileInfoDLOG
 */
void LoadTileInfoDLOG(DialogPtr d, MonsterRec *m)
{
	short	iType;
	Handle	iHandle;
	Rect	iRect;
	Str255	iText;
	long tmp;

	// Set TileOnTopOf
	tmp = (m->monsTileOnTopOf/4) + 1;
	if (tmp == 9) tmp = 5;
	if (tmp > 5) tmp = 0;
	GetDItem(d,kTileOnTopOf,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle, tmp);
	
	// Set X Coord
	tmp = m->monsPosition.h;
	NumToString(tmp,iText);
	GetDItem(d,kXPosition,&iType,&iHandle, &iRect);
	SetIText(iHandle,iText);
	
	// Set Y Coord
	tmp = m->monsPosition.v;
	NumToString(tmp,iText);
	GetDItem(d,kYPosition,&iType,&iHandle, &iRect);
	SetIText(iHandle,iText);

	// Set TALKSID
	tmp = m->monsTLKSID;
	NumToString(tmp,iText);
	GetDItem(d,kTLKSID,&iType,&iHandle, &iRect);
	SetIText(iHandle,iText);
	
	// Set inclination
	tmp = m->monsInclination / 4 + 1;
	GetDItem(d,kInclination,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle, tmp);
	
	// Set Tile Type in Dlog's RefCon
	((DialogPeek)d)->window.refCon = m->monsTileType;
	CheckTMItem(m->monsTileType / 4 + 1);
	
	// Draw proper tile type
	// should become a popup menu soon.
	tmp = m->monsTileType / 4 + 1;
	MyGetIndString(iText,gScenario.strings[0].strn,tmp);
	GetDItem(d,kTileType,&iType,&iHandle, &iRect);
	SetIText(iHandle,iText);
	
	// Finally, set the X coordinate as the active text:
	SelIText(d,kXPosition,0,32767);
}

void SaveTileInfoDLOG(DialogPtr d,short mapID, short monsID)
{
	MonsterRec m;
	short	iType;
	Handle	iHandle;
	Rect	iRect;
	Str255	iText;
	long tmp;

	// TileOnTopOf
	GetDItem(d,kTileOnTopOf,&iType,&iHandle, &iRect);
	tmp = GetCtlValue((ControlHandle)iHandle);
	if (tmp == 5) tmp = 9;
	m.monsTileOnTopOf = (tmp - 1) * 4;
	
	// X Coord
	GetDItem(d,kXPosition,&iType,&iHandle, &iRect);
	GetIText(iHandle,iText);
	StringToNum(iText,&tmp);
	m.monsPosition.h = tmp;
	
	// Y Coord
	GetDItem(d,kYPosition,&iType,&iHandle, &iRect);
	GetIText(iHandle,iText);
	StringToNum(iText,&tmp);
	m.monsPosition.v = tmp;

	// TALKSID
	GetDItem(d,kTLKSID,&iType,&iHandle, &iRect);
	GetIText(iHandle,iText);
	StringToNum(iText,&tmp);
	m.monsTLKSID = tmp;
	
	// Set inclination
	GetDItem(d,kInclination,&iType,&iHandle, &iRect);
	m.monsInclination = (GetCtlValue((ControlHandle)iHandle) - 1) * 4;
	
	// Set Tile Type in Dlog's RefCon
	m.monsTileType = ((DialogPeek)d)->window.refCon;
	
	m.monsNumber = monsID;

	SetMonster(mapID,&m);	
}

/* TileInfoKeyProc
 * Based on AlertKeyProc.
 */
#define kEnterKey		3
#define kReturnKey		13
#define kEscapeKey		27
pascal Boolean TileInfoKeyProc(DialogPtr d, EventRecord *e, short *itemHit)
{
	char 	theChar;
	short	num, i, iType;
	Handle	iHandle;
	Rect	iRect;
	Str255	iText,iName;
	
	ModalFilterUPP	stdFilterProc;
	Boolean ret;
	OSErr	err;
	Point point;

	short	item;
	DialogRecord *dr;
	long size,maxEntry;

	switch(e->what) {
	case mouseDown:
		point = e->where;
		GlobalToLocal(&point);
		if (TIIsTilePopupClick(d,point)){
			MenuHandle menu;
			long menuChoice;
			
			GetDItem(d,kTile,&iType, &iHandle, &iRect);	
			InsetRect(&iRect, -1,-1);
			TMInvertItem2(&iRect);
			
			menu = GetMenu(200);
			InsertMenu(menu,-1);
			SetPt(&point, iRect.left,iRect.top);
			LocalToGlobal(&point);
			menuChoice = PopUpMenuSelect(menu, point.v, point.h, 1);
			DeleteMenu(200);
			TMInvertItem2(&iRect);
	
			if (HiWord(menuChoice) == mTiles) {
				menuChoice = (long)LoWord(menuChoice);
				if (menuChoice == 1) {
					DoBadTileDialog();
				} else {
					((DialogPeek)d)->window.refCon = (menuChoice-1) * 4;
					CheckTMItem((short)menuChoice);
					TIDrawTilePopup(d);
					// Draw proper tile type
					// should become a popup menu soon.
					MyGetIndString(iText,gScenario.strings[0].strn,menuChoice);
					GetDItem(d,kTileType,&iType,&iHandle, &iRect);
					SetIText(iHandle,iText);
				}
			}
			return ;
		}		
		break;
	case updateEvt:
		//BeginUpdate(d);
		DrawTileInfoDLOG(d);
		//EndUpdate(d);
		break;
	case keyDown:
	case autoKey:
		theChar = (e->message & charCodeMask);
		
		// MDT 1/31/96 turn balloon help on/off
		if (theChar == 0x05) {
			(void) HMSetBalloons(!HMGetBalloons()); 
			return true;
		}
		
		if (theChar == kReturnKey || theChar == kEnterKey) {
			GetDItem(d, 1, &iType, &iHandle, &iRect);
			FlashButton((ControlHandle)iHandle);
			
			*itemHit = 1;
			return (true);
		} else if ( (theChar == kEscapeKey) ||
				   ((theChar == '.') && (e->modifiers & cmdKey) ))  {
			GetDItem(d, 2, &iType, &iHandle, &iRect);
			if (iType == ctrlItem + btnCtrl) {		/* If there is a Button */
				FlashButton((ControlHandle)iHandle);
			
				*itemHit = 2;
				return (true);
			} else {
				return (false);
			}
		} else {
			//if ((e->modifiers & cmdKey)) { /* Only work if command key is down */
			num = CountDITL(d);
			for (i=1; i<=num; i++) {
				GetDItem(d, i, &iType, &iHandle, &iRect);
				if (iType == ctrlItem + btnCtrl) {
					GetCTitle((ControlHandle)iHandle, iText);
					if (theChar == iText[1] || theChar == (char)(iText[1] + 32)){
						FlashButton((ControlHandle)iHandle);
						*itemHit = i;
						return (true);
					}	// if
				}	// if
			}	// for
			
			// else, barring all the above, make sure numbers are entered correctly.
			if (IsDlgControl(theChar)) break;
			
			dr = (DialogRecord *)d;
			item = dr->editField+1;
			MakeDLOGString(d,e,item,iText);
			
			// make sure every character is legal
			for (i=1; i<=iText[0]; i++) {
				if (! IsNumber(iText[i]))
					return AbortEvent(e,true);
			}
			
			StringToNum(iText,&size);
			
			switch(item) {
			case kXPosition:
				maxEntry = mpSize-1;
				PStringCopy("\pX Position", iName);
				break;
			case kYPosition:
				maxEntry = mpSize-1;
				PStringCopy("\pY Position",iName);
				break;
			case kTLKSID:
				maxEntry = 15;
				PStringCopy("\pTLKS ID", iName);
				break;
			default:
				maxEntry = 0;
				PStringCopy("\p<Unknown>", iName);
			}
			if (size > maxEntry) {
				DoBadRangeDialog(iName,maxEntry);
				AbortEvent(e,false);
			}

			//}	// if
		} // else
		break;
	default:
		;
	}	// switch
	
	// call the standard filter proc
	return StdFilterProc(d,e,itemHit);
}

void DoBadTileDialog (void)
{
	DialogPtr d;
	GrafPtr save;
	Boolean done = false;
	ModalFilterUPP upp;
	short itemHit;
	
	SysBeep(3);
	
	GetPort(&save);
	d = GetNewDialog(kBadTileDLOGID, nil, (WindowPtr)-1L);
	if (!d) {
		DoError("\pCould not load Bad Tile Dialog!",0,kNotFatal);
		return;
	}
	ShowWindow(d);
	SetPort(d);
	(void) SetDialogDefaultItem(d,kOK);

	upp = NewModalFilterProc(AlertKeyProc);

	while (!done) {
		ModalDialog(upp,&itemHit);
		
		switch (itemHit) {
		case kOK: // ok
			done = true;
			break;
		default:
			;
		}
	}
	DisposeRoutineDescriptor(upp);
	SetPort(save);
	DisposeDialog(d);
}

void DoBadRangeDialog (Str255 itemName, long max)
{
	DialogPtr d;
	GrafPtr save;
	Boolean done = false;
	ModalFilterUPP upp;
	short itemHit;
	Str255 itemMax;
	
	NumToString(max,itemMax);
	
	SysBeep(3);
	
	ParamText(itemName,itemMax,"\p","\p");
	GetPort(&save);
	d = GetNewDialog(kBadRangeDLOGID, nil, (WindowPtr)-1L);
	if (!d) {
		DoError("\pCould not load Bad Tile Dialog!",0,kNotFatal);
		return;
	}
	ShowWindow(d);
	SetPort(d);
	(void) SetDialogDefaultItem(d,kOK);

	upp = NewModalFilterProc(AlertKeyProc);

	while (!done) {
		ModalDialog(upp,&itemHit);
		
		switch (itemHit) {
		case kOK: // ok
			done = true;
			break;
		default:
			;
		}
	}
	DisposeRoutineDescriptor(upp);
	SetPort(save);
	DisposeDialog(d);
}

/* DrawTileInfoDLOG
 * Should be called in UpdateEvents and whatnot.
 */
void DrawTileInfoDLOG(DialogPtr d)
{
	Rect caption,controlGroup,iRect;
	short iType;
	Handle iHandle;
	
	// draw tile popup
	TIDrawTilePopup(d);
	
	// frame control groups.
	GetDItem(d,kPositionLit,&iType, &iHandle, &caption);
	GetDItem(d,kPosBox,&iType, &iHandle, &controlGroup);
	DrawControlGroup(controlGroup,caption);
	
	GetDItem(d,kBehaviorLit,&iType, &iHandle, &caption);
	GetDItem(d,kBehBox,&iType, &iHandle, &controlGroup);
	DrawControlGroup(controlGroup,caption);
	
	DrawDefaultButton(d);
}

/* Draws one of them nifty boxes with controls in it. Pay attention:
 *   controlGroup	- rect containing the bounds of the box to draw.
 *   caption		- rect containing the caption label.
 * NOTE: this routine doesn't ensure the label is positioned properly
 * within the controlGroup. That's YOUR job!!!
 */
void DrawControlGroup(Rect controlGroup, Rect caption)
{
	short tmp;
	
	MoveTo(controlGroup.left,controlGroup.top);
	tmp = caption.left - controlGroup.left;
	if (tmp < 0) tmp = 0;
	LineTo(controlGroup.left + tmp, controlGroup.top);
	tmp = controlGroup.right - caption.right;
	if (tmp < 0) tmp = 0;
	MoveTo(controlGroup.right - tmp,controlGroup.top);
	LineTo(controlGroup.right,controlGroup.top);
	LineTo(controlGroup.right,controlGroup.bottom);
	LineTo(controlGroup.left,controlGroup.bottom);
	LineTo(controlGroup.left,controlGroup.top);
}

/* The following were stolen from Map Window.c */
void TIDrawTilePopup(DialogPtr d)
{
	short	iType;
	Handle	iHandle;
	Rect	iRect;
	
	// draw tile
	GetDItem(d,kTile,&iType, &iHandle, &iRect);	
	//   plot tile in iRect;
	PlotTile(gScenario.tiles,(short)((DialogPeek)d)->window.refCon,nil,&iRect);
	//   draw frame
	InsetRect(&iRect,-2,-2);
	FrameRect(&iRect);
}

Boolean TIIsTilePopupClick(DialogPtr d,Point localPt)
{
	short	iType;
	Handle	iHandle;
	Rect	iRect;
	
	// draw tile
	GetDItem(d,kTile,&iType, &iHandle, &iRect);	
	InsetRect(&iRect, -2,-2);
	
	return (PtInRect(localPt, &iRect));
}

