/*
 * About.c
 */

#include "Alertsx.h"
#include "About.h"
#include "MMR.h"
#include "Menusx.h"

//#define kAboutWindowID		200
//#define kAboutPICTID		200
#define kAboutWindowID		201
#define kAboutPICTID		201
#define kVersTextOffsetV	10
#define kVersTextOffsetH	10

CWindowPtr gAboutWindow = nil;
PicHandle  gAboutPict = nil;

void GetVersString(Str255 versStr);

void OpenAbout(void)
{
	MenuHandle menu;
	short i;
	Str255 tmp,version;
	RGBColor save,green = {0x4444,0xFFFF,0x0000},black={0,0,0};
	
	//for (i = mFile; i <= mWindows; i++) {
		menu = GetMenu(mFile);
		//if (!menu) continue; // error checking
		DisableItem(menu,0);
	//}
	DrawMenuBar();
		
	gAboutWindow = (CWindowPtr)GetNewCWindow(kAboutWindowID,nil,(WindowPtr)-1L);
	if (!gAboutWindow) {
		DoError("\pCan't load AboutWindow!",0,kNotFatal);
		return;
	}
	ShowWindow((WindowPtr)gAboutWindow);
	SetPort((WindowPtr)gAboutWindow);
	gAboutWindow->txFont = 0; // system font
	//gAboutWindow->txFace = 1; // bold
	
	gAboutPict = GetPicture(kAboutPICTID);
	if (!gAboutPict) {
		DoError("\pCan't load AboutPict!",0,kNotFatal);
		CloseAbout();
		return;
	}
	
	DrawPicture(gAboutPict,&(*gAboutPict)->picFrame);
	
	//Draw version number.
	GetForeColor(&save);
	GetVersString(tmp);
	PStringCopy("\pVersion: ",version);
	PStringCat(version,tmp);
	
	MoveTo(((*gAboutPict)->picFrame.left + kVersTextOffsetH)+2, ((*gAboutPict)->picFrame.bottom - kVersTextOffsetV)+2);
	RGBForeColor(&black);
	//TextSize(14);
	DrawString(version);
	MoveTo(((*gAboutPict)->picFrame.left + kVersTextOffsetH), ((*gAboutPict)->picFrame.bottom - kVersTextOffsetV));
	//TextSize(0);
	RGBForeColor(&green);
	DrawString(version);
	RGBForeColor(&save);
}

void CloseAbout(void)
{
	MenuHandle menu;
	short i;

	if (gAboutPict) {
		ReleaseResource((Handle)gAboutPict);
		gAboutPict = nil;
	}
	if (gAboutWindow) {
		DisposeWindow((WindowPtr)gAboutWindow);
		gAboutWindow = nil;
	}
	
	//for (i = mFile; i <= mWindows; i++) {
		menu = GetMenu(mFile);
		//if (!menu) continue; // error checking
		EnableItem(menu,0);
	//}
	DrawMenuBar();
}


/* GetVersString
 * Reads 'vers' resource #1 and constructs a string like "\p1.0d3"...
 * If it can't find 'vers' #1, it returns an empty string.
 */
void GetVersString(Str255 versStr)
{
	Handle	versHdl;
	long	version;
	unsigned char	ver1,ver2,ver3,relStatus,prerelNum;
	Str255	tmp;
	
	// clear string;
	versStr[0]=0;
	
	// read version no. information
	versHdl = GetResource('vers',1);
	if (!versHdl) {
		return;
	}
	version = *((long *)(*versHdl));
	ReleaseResource(versHdl);
	
	// Set ver1-3, relStatus, prerelNum from the version info.
	// Note that the first two bytes are in an unusual format.
	ver1 = ((char *)&version)[0];
	ver1 = (((ver1 & 0xF0) >> 4) * 10) + (ver1 & 0x0F);
	ver2 = (((char *)&version)[1] & 0xF0) >> 4;
	ver3 = (((char *)&version)[1] & 0x0F);
	relStatus = ((char *)&version)[2];
	prerelNum = ((char *)&version)[3];

	// Insert v1 and v2 into our version string.
	NumToString((long)ver1,tmp);
	PStringCat(versStr,tmp);
	PStringCat(versStr,"\p.");
	NumToString((long)ver2,tmp);
	PStringCat(versStr,tmp);	
	// For convenience, we only print the third number if it is  non-zero.
	// If you always want all three numbers, remove the if-statement.
	if (ver3) { 
		PStringCat(versStr,"\p.");
		NumToString((long)ver3,tmp);
		PStringCat(versStr,tmp);
	}
	
	// If the release status is development, alpha, or beta, add a 
	// 'd', 'a', or 'b' to our version string.
	switch(relStatus){
	case 0x20:	// development
		PStringCat(versStr,"\pd");
		break;
	case 0x40:	// alpha
		PStringCat(versStr,"\pa");
		break;
	case 0x60:	// beta
		PStringCat(versStr,"\pb");
		break;
	default:	 
		;
	}
	
	// lastly, if we've added a 'd', 'a', or 'b', print the pre-release
	// number at the end.
	if (relStatus != 0x80) {
		NumToString((long)prerelNum,tmp);
		PStringCat(versStr,tmp);
	}
}