/*
 * Cursors30.h
 */

#ifndef __CURSORS__
#define __CURSORS__

#include "LinkedList.h"

enum CCType {
	single = 0,
	animation
};
typedef enum CCType CCType;

struct ACUR {
	short numFrames;
	short curFrame;
	short  frames[];
};
typedef struct ACUR ACUR,*ACURPtr,**ACURHandle;

struct CCCursorRec {
	CCType		type;
	short   	id;
	Boolean 	autoDispose;
	CCrsrHandle	simpleCrsr;
	CCrsrHandle	*animCrsrs;
	ACURHandle  aCur;
	long		animRate;
	long		changeTicks;
};
typedef struct CCCursorRec CCCursorRec, *CCCursorPtr;
// NOTE: acur is a reserved word defined in CursorCtl.h. So I changed the name ... 


enum CCStatus {
	off = 0,
	simple,
	arrow,
	norml,
	command,
	option,
	shift,
	control
};
typedef enum CCStatus CCStatus;

#define kCCNormalCursor		0
#define kCCCommandCursor	1
#define kCCOptionCursor		2
#define kCCShiftCursor		3
#define kCCControlCursor	4

#define kCCCursNumber		5


struct RegionNode {
	RgnHandle	rgn;
	CCCursorPtr cursors[kCCCursNumber]; 
};
typedef struct RegionNode RegionNode;

struct WindowNode {
	WindowPtr	window;
	LinkedListPtr rgns;
	RegionNode	*activeRN;
	RgnHandle	unionRgn;
	CCStatus    status;
	CCCursorPtr anim;
};
typedef struct WindowNode WindowNode;

CCCursorPtr	CCNewCursor(CCType type, short id, Boolean autoDispose);
void CCDisposeCursor(CCCursorPtr cr);
void CCAnimateCursor(WindowNode *wn);
void CCSetRegion(WindowPtr w, RgnHandle rgn, CCCursorPtr norm, CCCursorPtr cmd, CCCursorPtr opt, CCCursorPtr shift, CCCursorPtr ctl);
void CCRemoveRegion(WindowPtr w, RgnHandle rgn);
void CCRemoveWindow(WindowPtr w);
void CCSimpleCursor(CCType type, short crsrID, Boolean enable);
void CCTrackCursor(WindowPtr w, Boolean enable);
void CCMouseMoved(void);
void CCEventProcessing(void);
RgnHandle CCMouseRgn(void);

#endif // __CURSORS__