/*
 * Map Window.h
 */

#ifndef __MAPWINDOW__
#define __MAPWINDOW__

#include <QDOffscreen.h>
#include "Monsters.h"

#define kCItemHeight	21
#define kCItemWidth		24
#define kControlHeight	0 // not used ... 
#define kControlWidth	2
#define kControlBorder	3 
//#define kNumTools		16
#define kNumTools		8

struct MapWindowData {
	WindowPtr		mapWindow;
	GWorldPtr		mapWorld;
	ControlHandle	mapHScroll,
					mapVScroll,
					toolPalette;
	short 			mapID, tileType;
	Boolean 		dirty;
	short			crsrID;
	Rect			selectedPts;
	
	//kluge for monster dragging support
	MonsterRec		monster;
};
typedef struct MapWindowData MapWindowData;

WindowPtr	NewMapWindow(short mapID);
void CloseMapWindow(WindowPtr w);
//void CloseAllMapWindows(void);
OSErr ResizeMapWindow(WindowPtr window, EventRecord *e);
void MoveMapWindow(WindowPtr w, EventRecord *e, Rect *limitRect);
void MapUpdate(WindowPtr w);
void DrawMapWindow(WindowPtr w);
void CalculateMapWindow(WindowPtr w);
void CalcAndDrawMapWindow(WindowPtr w) ;
void SetTileType(WindowPtr w,short tile);
void HandleMapKey(WindowPtr w,EventRecord *e, short theChar);
void HandleMapContentClick(WindowPtr w, EventRecord *e);
void DrawTilePopup(WindowPtr w);
Boolean PtInSelectedRect(WindowPtr w,Point p);
void InvertSelectedRect(WindowPtr w);
void CalcMapRect(WindowPtr w,Rect *r);
void CalcAndDrawMapWindow(WindowPtr w) ;
void MPtoQDRect(WindowPtr w, Rect *MPRect, Rect *QDRect);
WindowPtr FindMapWindow(short mapID);
void ForEachMapWindowDo(void (*func)(WindowPtr wp));
void AutoSizeMapWindow(WindowPtr w);
void DrawMapWindow(WindowPtr w);
void MapActivate(WindowPtr w, Boolean activate);

#endif // __MAPWINDOW__
