#ifndef __MULTIPANE__
#define __MULTIPANE__

/* Item Caching flag. Comment out this line to prevent item caching. Item Caching is 
 * somewhat dangerous, since it relies on reverse-engineered DITL information.
 */
#define __PERFORM_ITEM_CACHING__


#ifdef __PERFORM_ITEM_CACHING__
// Undocumented Resource Formats
struct DITLItem {
	Handle		itmHndl;
	Rect		itmRect;
	char		itmType;
	char		itmData[];
};
typedef struct DITLItem DITLItem, *DITLItemPtr, **DITLItemHdl;

struct ItemList {
	short		dlgMaxIndex;
	DITLItem	DITLItems[];
};
typedef struct ItemList ItemList, *ItemListPtr, **ItemListHdl;

// Our item types (used with undocumented above)
struct MPDITLItem {
	char	itmType;
	short	itmValue;
	Str255	itmString; // mem hog - this should be a pointer
};
typedef struct MPDITLItem MPDITLItem, *MPDITLItemPtr;

struct MPItemList {
	short 		itemCnt;
	MPDITLItem	*mpDITLItems;
};
typedef struct MPItemList MPItemList, *MPItemListPtr;

#endif // __PERFORM_ITEM_CACHING__

// Our MPDialogRecord type
struct MPDialogRecord {
	DialogRecord	dlogRecord;		// master dialog storage 
	DialogPtr		dlogPtr;		// master dialog ptr
	short 			dlogID;			// master dialog id
	short			dlogItemCnt;	// master dialog item count
	short 			numPanes;		// number of sub panes
	short			*subPaneIDs;	// sub-pane DITL IDs
	short			subPaneNum; 	// active sub-pane number
	short			customErase;	// custom erase item (on Master Pane)
	
#ifdef __PERFORM_ITEM_CACHING__
	// evil items dabbling in the undocumented ...
	MPItemList		*subPaneItems;	// sub-pane items
#endif // __PERFORM_ITEM_CACHING__
};
typedef struct MPDialogRecord MPDialogRecord;
	

#define kDefaultPane -1


DialogPtr GetNewMPDialog(short dID, Ptr dStorage, WindowPtr behind);
void 	  CloseMPDialog(DialogPtr mpDialog);
void	  DisposeMPDialog(DialogPtr mpDialog);
void 	  SetMPDialogPane(DialogPtr mpDialog, short paneNum);
short 	  GetMPDialogPane(DialogPtr mpDialog);
void      MPItemHit(DialogPtr mpDialog, short *itemHit, short *paneNum);
short	  GetMPDialogItemCount(DialogPtr mpDialog);
void 	  SetMPCustomEraseItem(DialogPtr mpDialog, short item);

#ifdef __PERFORM_ITEM_CACHING__
void 	  SetMPCtlValue(DialogPtr mpDialog, short value, short item, short pane);
short 	  GetMPCtlValue(DialogPtr mpDialog, short item, short pane);
void 	  SetMPIText(DialogPtr mpDialog,Str255 str, short item, short pane);
void 	  GetMPIText(DialogPtr mpDialog,Str255 str, short item, short pane);
#endif // __PERFORM_ITEM_CACHING__

#endif // __MULTIPANE__