/*
 * Scen Window.c
 *
 * Code for the Scenario Window itself. Does not include the list stuff.
 */

#include "Alertsx.h"
#include "MMR.h"
#include "Scen Window.h"
#include "Scen List.h"
#include "Menusx.h"
#include "Cursors30.h"

#include "Scenario.h"

#define kScenWindowID		128
#define kCloseDialogID		130

WindowPtr	gScenWindow = nil;
// list item

void DrawScenWindow(void); // private
short DoCloseDialog(void);

WindowPtr	NewScenWindow(void)
{
	WindowPtr	w;
	WindowPeek	wPeek;
	WStateData	*wsdp;
	Rect r;
	if (gScenWindow) return gScenWindow; // weird side effect
	
	w = GetNewCWindow(kScenWindowID,nil, (WindowPtr)-1L);
	
	if (w) {
		// set zoom
	/*	wPeek = (WindowPeek)w;
		wsdp = (WStateData*) *(wPeek->dataHandle);
		SetRect(&wsdp->stdState, 3, GetMBarHeight()+18+3, 320,16*14+16);*/
		
		// Make list
		r = w->portRect;		
		/*r.top += 15; */r.bottom -= 15; // Make room for other things in window.
		
		(void) NewScenList( w,&r);
	}
		
	gScenWindow = w;
	
	MyDrawGrowIcon(w);
	BuildWindowMenu();

	return w;
}

Boolean CloseScenWindow(void)
{
	switch (DoCloseDialog()) {
	case 1:
		if (gScenario.file) SaveScenarioFile(gScenario.file);
		break;
	case 2:
		return false; // don't close
		break; // nothing
	default:
		;
	}

	DisposeScenList();
	DisposeWindow(gScenWindow);
	gScenWindow = nil;	
	CloseScenarioFile(gScenario.file); 
	UpdateFileMenu();
	BuildWindowMenu();
	
	return true;
}

short DoCloseDialog(void)
{
	DialogPtr d;
	short itemHit;
	GrafPtr save;
	ModalFilterUPP upp;
	WindowPtr w = FrontWindow();
	
	//SuspendCursTracking();
	CCTrackCursor(w,false);
	
	if (gScenario.scenDirty == false) return 3; // we don't need to save.
	
	GetPort(&save);
	
	d = GetNewDialog(kCloseDialogID,0L,(WindowPtr)-1L);
	if (!d) {
		DoError("\pCan't Load \"Save Y/N/C Dialog\"! Data will not be saved.",0,false);
		return 3;
	}
	ShowWindow(d);
	SetPort(d);
	(void) SetDialogDefaultItem(d,1);
	(void) SetDialogCancelItem(d,2);
	
	//DrawDefaultButton(d);
	
	upp = NewModalFilterProc(AlertKeyProc);
	ModalDialog(upp,&itemHit);
	DisposeRoutineDescriptor(upp);
	
	SetPort(save);
	DisposeDialog(d);
	
//	ResumeCursTracking(w);
	CCTrackCursor(w,true);
	return itemHit;
}


OSErr ResizeScenWindow(EventRecord *e)
{
	Rect sizeRect,eraseRect;
	OSErr err = noErr;
	long windSize;
	short h,w;
	RgnHandle rgn,saveRgn;
	
	SetPort(gScenWindow); // paranoid
	
	SetRect(&sizeRect, 100,100,320,16*14+16);

	windSize = GrowWindow(gScenWindow, e->where, &sizeRect);
	
	if (windSize) {	
		sizeRect = gScenWindow->portRect;
		//sizeRect.bottom -= 14; sizeRect.right -= 14;

		h = HiWord(windSize);
		w = LoWord(windSize);
		SizeWindow(gScenWindow, w, h, true);
		eraseRect = gScenWindow->portRect;
		
		// Clip out old screen region
		saveRgn = NewRgn();
		GetClip(saveRgn);
		rgn = NewRgn();
		OpenRgn();
		FrameRect(&eraseRect);
		FrameRect(&sizeRect);
		CloseRgn(rgn);
		SetClip(rgn);
		DisposeRgn(rgn);
		
		// Erase new screen region
		EraseRect(&eraseRect);
	
		SetClip(saveRgn);
		DisposeRgn(saveRgn);
		
		InvalRect(&(gScenWindow->portRect)); // we force an update of the window 
		
		ResizeScenList(&(gScenWindow->portRect));

	}
	
	return noErr;
}

void ScenUpdate(void)
{
	BeginUpdate(gScenWindow);
	// draw list
	//DrawScenWindow();
	DrawGrowIcon(gScenWindow);
	EndUpdate(gScenWindow);
	
	UpdateScenList(gScenWindow);
}

void ScenActivate(Boolean activate)
{
	if (gScenWindow == nil) return;
	ActivateScenList(gScenWindow,activate);
}

void DrawScenWindow()
{
	RgnHandle saveRgn;
	
	saveRgn = NewRgn();
	GetClip(saveRgn);

	SetPort(gScenWindow);

	// do our drawing
	SetClip(saveRgn);
	DisposeRgn(saveRgn);
}

void HandleScenContentClick(EventRecord *e)
{
	short 			thePart;
	ControlHandle	theControl;
	Point			thePoint;
	ControlActionUPP controlAction;
	
	SetPort(gScenWindow);
	thePoint = e->where;
	GlobalToLocal(&thePoint);
	
	// Do whatever we need to do for the list item
	HandleScenListClick(e);
}

void HandleScenarioKey(EventRecord *e, short theChar)
{
	HandleScenListKey(e,theChar);
}