#ifndef __TOOLS__
#define __TOOLS__

#include "Map Window.h"
#include "ToolPaletteCDEF.h"

#define kToolPicture		128
//#define kNumTools			16 // 2/1/96 moved to ToolPaletteCDEF.h
#define kToolSmallOffset	8
#define kToolLargeOffset	16
#define kToolWidth			(kControlBorder * 2) + (kControlWidth * kCItemWidth)
#define kToolHeight			(kControlBorder * 2) + ((kNumTools+1)/2 * kCItemHeight - (kNumTools - 1)) 
// for kToolHeight, (kNumTools+1)/2 is ceiling(kNumTools/2). Think about it.

#define kToolPointer		1
#define kToolSelect			2
#define kToolEraser			3
#define kToolPencil			4
#define kToolEyeDropper		5
#define kToolPaintBucket	6
#define kToolLetter			7
#define kToolMonsterInfo	8	// new as of 1/22/96
#define kToolMonsterInsert	9	
#define kToolLine			10
#define kToolFullRect		11
#define kToolEmptyRect		12
#define kToolFullRoundRect	13
#define kToolEmptyRoundRect	14
#define kToolFullOval		15
#define kToolEmptyOval		16

Boolean DoEraser(Point initialPt, Point mapPt, MapWindowData *mwg);
Boolean DoPencil(Point initialPt, Point mapPt, MapWindowData *mwg);
Boolean DoEyeDropper(Point initialPt, Point mapPt, MapWindowData *mwg);
Boolean DoPaintBucket(Point initialPt, Point mapPt, MapWindowData *mwg);
Boolean DoLetter(Point initialPt, Point mapPt, MapWindowData *mwg);
void DoLetterKeyPress(short letter, Boolean adjust, MapWindowData *mwg);
Boolean DoSelect(Point initialPt, Point mapPt, MapWindowData *mwg);

Boolean DoPlotMonster(Point initialPt, Point mapPt, MapWindowData *mwg);
Boolean DoDragMonster(Point initialPt, Point mapPt, MapWindowData *mwg);


extern unsigned long debugStack;

#endif __TOOLS__