#ifndef __WATCHCURSOR__
#define __WATCHCURSOR__

#define kWatchOn		1
#define kWatchOff		0
#define kWatchSpin		-1

/* DoWatchCursor
 * Implements a simple spinning watch cursor.
 *   w		- included for backwards compatability.
 *	 action	- a constant, containing one of three values:
 *               kWatchOn   - turns watch cursor on.
 *               kWatchOff  - turns watch cursor off, freeing memory.
 *               kWatchSpin - increments the watch cursor by one frame.
 *            Note that a given action may be performed more than once without
 *            any unusual effects (save kWatchSpin, of course). kWatchSpin
 *            can be called w/o calling kWatchOn first.
 */
void DoWatchCursor(WindowPtr w, short action);

#endif // __WATCHCURSOR__